/**
 * DiscoverSnoop
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.240913
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *//* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs';

import { Alerts } from '../model/alerts';
import { Domains } from '../model/domains';
import { TransactionInfo } from '../model/transactionInfo';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class AlertsService {

    protected basePath = 'https://api.discoversnoop.com';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (const consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * Edit or insert new alert
     * 
     * @param id ID of the alert to edit ; if adding a new one leave blank
     * @param alertname Name of the alert
     * @param activated Should the alert be activated or not
     * @param type Alert type (1&#x3D; New content for website, 2&#x3D;New perfirming contents)
     * @param channel 1 for email, 2 for Slack, 3 for Google Chat
     * @param recipient Email address of recipient or webhook for Slack/Gchat
     * @param param1 Parameter 1 (meaning changes with alert type)
     * @param param2 Parameter 2 (meaning changes with alert type)
     * @param param3 Parameter 3 (meaning changes with alert type)
     * @param param4 Parameter 4 (meaning changes with alert type)
     * @param param5 Parameter 5 (meaning changes with alert type)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public alertsChangeGet(id: string, alertname: string, activated: boolean, type: number, channel: number, recipient: string, param1?: string, param2?: string, param3?: string, param4?: string, param5?: string, observe?: 'body', reportProgress?: boolean): Observable<Array<Domains>>;
    public alertsChangeGet(id: string, alertname: string, activated: boolean, type: number, channel: number, recipient: string, param1?: string, param2?: string, param3?: string, param4?: string, param5?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<Domains>>>;
    public alertsChangeGet(id: string, alertname: string, activated: boolean, type: number, channel: number, recipient: string, param1?: string, param2?: string, param3?: string, param4?: string, param5?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<Domains>>>;
    public alertsChangeGet(id: string, alertname: string, activated: boolean, type: number, channel: number, recipient: string, param1?: string, param2?: string, param3?: string, param4?: string, param5?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling alertsChangeGet.');
        }

        if (alertname === null || alertname === undefined) {
            throw new Error('Required parameter alertname was null or undefined when calling alertsChangeGet.');
        }

        if (activated === null || activated === undefined) {
            throw new Error('Required parameter activated was null or undefined when calling alertsChangeGet.');
        }

        if (type === null || type === undefined) {
            throw new Error('Required parameter type was null or undefined when calling alertsChangeGet.');
        }

        if (channel === null || channel === undefined) {
            throw new Error('Required parameter channel was null or undefined when calling alertsChangeGet.');
        }

        if (recipient === null || recipient === undefined) {
            throw new Error('Required parameter recipient was null or undefined when calling alertsChangeGet.');
        }






        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (id !== undefined && id !== null) {
            queryParameters = queryParameters.set('id', <any>id);
        }
        if (alertname !== undefined && alertname !== null) {
            queryParameters = queryParameters.set('alertname', <any>alertname);
        }
        if (activated !== undefined && activated !== null) {
            queryParameters = queryParameters.set('activated', <any>activated);
        }
        if (type !== undefined && type !== null) {
            queryParameters = queryParameters.set('type', <any>type);
        }
        if (channel !== undefined && channel !== null) {
            queryParameters = queryParameters.set('channel', <any>channel);
        }
        if (recipient !== undefined && recipient !== null) {
            queryParameters = queryParameters.set('recipient', <any>recipient);
        }
        if (param1 !== undefined && param1 !== null) {
            queryParameters = queryParameters.set('param1', <any>param1);
        }
        if (param2 !== undefined && param2 !== null) {
            queryParameters = queryParameters.set('param2', <any>param2);
        }
        if (param3 !== undefined && param3 !== null) {
            queryParameters = queryParameters.set('param3', <any>param3);
        }
        if (param4 !== undefined && param4 !== null) {
            queryParameters = queryParameters.set('param4', <any>param4);
        }
        if (param5 !== undefined && param5 !== null) {
            queryParameters = queryParameters.set('param5', <any>param5);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<Domains>>('get',`${this.basePath}/alerts_change`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Permanently delete the alert
     * 
     * @param id alert id to delete
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public alertsDeleteGet(id: string, observe?: 'body', reportProgress?: boolean): Observable<Array<TransactionInfo>>;
    public alertsDeleteGet(id: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<TransactionInfo>>>;
    public alertsDeleteGet(id: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<TransactionInfo>>>;
    public alertsDeleteGet(id: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling alertsDeleteGet.');
        }

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (id !== undefined && id !== null) {
            queryParameters = queryParameters.set('id', <any>id);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<TransactionInfo>>('get',`${this.basePath}/alerts_delete`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Get alerts for user account
     * 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public alertsGet(observe?: 'body', reportProgress?: boolean): Observable<Array<Alerts>>;
    public alertsGet(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<Alerts>>>;
    public alertsGet(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<Alerts>>>;
    public alertsGet(observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<Alerts>>('get',`${this.basePath}/alerts`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
