/**
 * DiscoverSnoop
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.240913
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *//* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs';

import { Favs } from '../model/favs';
import { TransactionInfo } from '../model/transactionInfo';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class FavsService {

    protected basePath = 'https://api.discoversnoop.com';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (const consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * Create a new fav
     * 
     * @param name Name of the fav.
     * @param action Action to be opened.
     * @param parameters Action&#x27;s parameters encoded in JSON.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public favsAddGet(name?: string, action?: string, parameters?: string, observe?: 'body', reportProgress?: boolean): Observable<Array<TransactionInfo>>;
    public favsAddGet(name?: string, action?: string, parameters?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<TransactionInfo>>>;
    public favsAddGet(name?: string, action?: string, parameters?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<TransactionInfo>>>;
    public favsAddGet(name?: string, action?: string, parameters?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {




        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (name !== undefined && name !== null) {
            queryParameters = queryParameters.set('name', <any>name);
        }
        if (action !== undefined && action !== null) {
            queryParameters = queryParameters.set('action', <any>action);
        }
        if (parameters !== undefined && parameters !== null) {
            queryParameters = queryParameters.set('parameters', <any>parameters);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<TransactionInfo>>('get',`${this.basePath}/favs_add`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Permanently delete the fav
     * 
     * @param id ID of the fav to delete.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public favsDeleteGet(id?: string, observe?: 'body', reportProgress?: boolean): Observable<Array<TransactionInfo>>;
    public favsDeleteGet(id?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<TransactionInfo>>>;
    public favsDeleteGet(id?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<TransactionInfo>>>;
    public favsDeleteGet(id?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {


        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (id !== undefined && id !== null) {
            queryParameters = queryParameters.set('id', <any>id);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<TransactionInfo>>('get',`${this.basePath}/favs_delete`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Get favorites
     * 
     * @param id ID of the requested fav. ignore or set to 0 to get the full favs list
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public favsGet(id?: string, observe?: 'body', reportProgress?: boolean): Observable<Array<Favs>>;
    public favsGet(id?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<Favs>>>;
    public favsGet(id?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<Favs>>>;
    public favsGet(id?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {


        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (id !== undefined && id !== null) {
            queryParameters = queryParameters.set('id', <any>id);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<Favs>>('get',`${this.basePath}/favs`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Update the fav
     * 
     * @param id ID of the fav that should be edited
     * @param name Name of the fav.
     * @param action Action to be opened.
     * @param parameters Action&#x27;s parameters encoded in JSON.
     * @param scheduled 0 if not scheduled, else x in hours
     * @param scheduledto email address of the recipient of this report
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public favsUpdateGet(id: string, name?: string, action?: string, parameters?: string, scheduled?: number, scheduledto?: string, observe?: 'body', reportProgress?: boolean): Observable<Array<TransactionInfo>>;
    public favsUpdateGet(id: string, name?: string, action?: string, parameters?: string, scheduled?: number, scheduledto?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<TransactionInfo>>>;
    public favsUpdateGet(id: string, name?: string, action?: string, parameters?: string, scheduled?: number, scheduledto?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<TransactionInfo>>>;
    public favsUpdateGet(id: string, name?: string, action?: string, parameters?: string, scheduled?: number, scheduledto?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling favsUpdateGet.');
        }






        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (id !== undefined && id !== null) {
            queryParameters = queryParameters.set('id', <any>id);
        }
        if (name !== undefined && name !== null) {
            queryParameters = queryParameters.set('name', <any>name);
        }
        if (action !== undefined && action !== null) {
            queryParameters = queryParameters.set('action', <any>action);
        }
        if (parameters !== undefined && parameters !== null) {
            queryParameters = queryParameters.set('parameters', <any>parameters);
        }
        if (scheduled !== undefined && scheduled !== null) {
            queryParameters = queryParameters.set('scheduled', <any>scheduled);
        }
        if (scheduledto !== undefined && scheduledto !== null) {
            queryParameters = queryParameters.set('scheduledto', <any>scheduledto);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<TransactionInfo>>('get',`${this.basePath}/favs_update`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
