/**
 * DiscoverSnoop
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.240913
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *//* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs';

import { Categories } from '../model/categories';
import { Category } from '../model/category';
import { Domain } from '../model/domain';
import { Domains } from '../model/domains';
import { Page } from '../model/page';
import { Pages } from '../model/pages';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class HistoricalService {

    protected basePath = 'https://api.discoversnoop.com';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (const consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * Get historical stats for categories
     * 
     * @param country ISO_3166 country code in 2 letters
     * @param subcountry state code
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param keywordFilter Filter answers to cateogry names containing a particular keyword
     * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more)
     * @param offset Get paginated results from X offset
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public categoriesGet(country: string, subcountry?: string, fromDate?: string, toDate?: string, keywordFilter?: string, lines?: number, offset?: number, observe?: 'body', reportProgress?: boolean): Observable<Array<Categories>>;
    public categoriesGet(country: string, subcountry?: string, fromDate?: string, toDate?: string, keywordFilter?: string, lines?: number, offset?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<Categories>>>;
    public categoriesGet(country: string, subcountry?: string, fromDate?: string, toDate?: string, keywordFilter?: string, lines?: number, offset?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<Categories>>>;
    public categoriesGet(country: string, subcountry?: string, fromDate?: string, toDate?: string, keywordFilter?: string, lines?: number, offset?: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (country === null || country === undefined) {
            throw new Error('Required parameter country was null or undefined when calling categoriesGet.');
        }







        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (country !== undefined && country !== null) {
            queryParameters = queryParameters.set('country', <any>country);
        }
        if (subcountry !== undefined && subcountry !== null) {
            queryParameters = queryParameters.set('subcountry', <any>subcountry);
        }
        if (fromDate !== undefined && fromDate !== null) {
            queryParameters = queryParameters.set('from_date', <any>fromDate);
        }
        if (toDate !== undefined && toDate !== null) {
            queryParameters = queryParameters.set('to_date', <any>toDate);
        }
        if (keywordFilter !== undefined && keywordFilter !== null) {
            queryParameters = queryParameters.set('keyword_filter', <any>keywordFilter);
        }
        if (lines !== undefined && lines !== null) {
            queryParameters = queryParameters.set('lines', <any>lines);
        }
        if (offset !== undefined && offset !== null) {
            queryParameters = queryParameters.set('offset', <any>offset);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<Categories>>('get',`${this.basePath}/categories`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Get history for category ID
     * 
     * @param id category id
     * @param country ISO_3166 country code in 2 letters
     * @param subcountry state code
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public categoryGet(id: string, country: string, subcountry?: string, fromDate?: string, toDate?: string, observe?: 'body', reportProgress?: boolean): Observable<Array<Category>>;
    public categoryGet(id: string, country: string, subcountry?: string, fromDate?: string, toDate?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<Category>>>;
    public categoryGet(id: string, country: string, subcountry?: string, fromDate?: string, toDate?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<Category>>>;
    public categoryGet(id: string, country: string, subcountry?: string, fromDate?: string, toDate?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling categoryGet.');
        }

        if (country === null || country === undefined) {
            throw new Error('Required parameter country was null or undefined when calling categoryGet.');
        }




        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (id !== undefined && id !== null) {
            queryParameters = queryParameters.set('id', <any>id);
        }
        if (country !== undefined && country !== null) {
            queryParameters = queryParameters.set('country', <any>country);
        }
        if (subcountry !== undefined && subcountry !== null) {
            queryParameters = queryParameters.set('subcountry', <any>subcountry);
        }
        if (fromDate !== undefined && fromDate !== null) {
            queryParameters = queryParameters.set('from_date', <any>fromDate);
        }
        if (toDate !== undefined && toDate !== null) {
            queryParameters = queryParameters.set('to_date', <any>toDate);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<Category>>('get',`${this.basePath}/category`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Get history for domain name
     * 
     * @param domain domain name (no subdomain allowed)
     * @param country ISO_3166 country code in 2 letters
     * @param subcountry state code
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public domainGet(domain: string, country: string, subcountry?: string, fromDate?: string, toDate?: string, observe?: 'body', reportProgress?: boolean): Observable<Array<Domain>>;
    public domainGet(domain: string, country: string, subcountry?: string, fromDate?: string, toDate?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<Domain>>>;
    public domainGet(domain: string, country: string, subcountry?: string, fromDate?: string, toDate?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<Domain>>>;
    public domainGet(domain: string, country: string, subcountry?: string, fromDate?: string, toDate?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (domain === null || domain === undefined) {
            throw new Error('Required parameter domain was null or undefined when calling domainGet.');
        }

        if (country === null || country === undefined) {
            throw new Error('Required parameter country was null or undefined when calling domainGet.');
        }




        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (domain !== undefined && domain !== null) {
            queryParameters = queryParameters.set('domain', <any>domain);
        }
        if (country !== undefined && country !== null) {
            queryParameters = queryParameters.set('country', <any>country);
        }
        if (subcountry !== undefined && subcountry !== null) {
            queryParameters = queryParameters.set('subcountry', <any>subcountry);
        }
        if (fromDate !== undefined && fromDate !== null) {
            queryParameters = queryParameters.set('from_date', <any>fromDate);
        }
        if (toDate !== undefined && toDate !== null) {
            queryParameters = queryParameters.set('to_date', <any>toDate);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<Domain>>('get',`${this.basePath}/domain`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Get historical stats for domains
     * 
     * @param country ISO_3166 country code in 2 letters
     * @param subcountry state code
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param urlFilter Filter answers to domains including a specified string
     * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more)
     * @param offset Get paginated results from X offset
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public domainsGet(country: string, subcountry?: string, fromDate?: string, toDate?: string, urlFilter?: string, lines?: number, offset?: number, observe?: 'body', reportProgress?: boolean): Observable<Array<Domains>>;
    public domainsGet(country: string, subcountry?: string, fromDate?: string, toDate?: string, urlFilter?: string, lines?: number, offset?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<Domains>>>;
    public domainsGet(country: string, subcountry?: string, fromDate?: string, toDate?: string, urlFilter?: string, lines?: number, offset?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<Domains>>>;
    public domainsGet(country: string, subcountry?: string, fromDate?: string, toDate?: string, urlFilter?: string, lines?: number, offset?: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (country === null || country === undefined) {
            throw new Error('Required parameter country was null or undefined when calling domainsGet.');
        }







        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (country !== undefined && country !== null) {
            queryParameters = queryParameters.set('country', <any>country);
        }
        if (subcountry !== undefined && subcountry !== null) {
            queryParameters = queryParameters.set('subcountry', <any>subcountry);
        }
        if (fromDate !== undefined && fromDate !== null) {
            queryParameters = queryParameters.set('from_date', <any>fromDate);
        }
        if (toDate !== undefined && toDate !== null) {
            queryParameters = queryParameters.set('to_date', <any>toDate);
        }
        if (urlFilter !== undefined && urlFilter !== null) {
            queryParameters = queryParameters.set('url_filter', <any>urlFilter);
        }
        if (lines !== undefined && lines !== null) {
            queryParameters = queryParameters.set('lines', <any>lines);
        }
        if (offset !== undefined && offset !== null) {
            queryParameters = queryParameters.set('offset', <any>offset);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<Domains>>('get',`${this.basePath}/domains`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Get page history for URL
     * 
     * @param url Fully qualified page url. URL needs to be URL encoded
     * @param country ISO_3166 country code in 2 letters
     * @param subcountry state code
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public pageGet(url: string, country: string, subcountry?: string, fromDate?: string, toDate?: string, observe?: 'body', reportProgress?: boolean): Observable<Array<Page>>;
    public pageGet(url: string, country: string, subcountry?: string, fromDate?: string, toDate?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<Page>>>;
    public pageGet(url: string, country: string, subcountry?: string, fromDate?: string, toDate?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<Page>>>;
    public pageGet(url: string, country: string, subcountry?: string, fromDate?: string, toDate?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (url === null || url === undefined) {
            throw new Error('Required parameter url was null or undefined when calling pageGet.');
        }

        if (country === null || country === undefined) {
            throw new Error('Required parameter country was null or undefined when calling pageGet.');
        }




        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (url !== undefined && url !== null) {
            queryParameters = queryParameters.set('url', <any>url);
        }
        if (country !== undefined && country !== null) {
            queryParameters = queryParameters.set('country', <any>country);
        }
        if (subcountry !== undefined && subcountry !== null) {
            queryParameters = queryParameters.set('subcountry', <any>subcountry);
        }
        if (fromDate !== undefined && fromDate !== null) {
            queryParameters = queryParameters.set('from_date', <any>fromDate);
        }
        if (toDate !== undefined && toDate !== null) {
            queryParameters = queryParameters.set('to_date', <any>toDate);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<Page>>('get',`${this.basePath}/page`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Get historical stats for pages
     * 
     * @param presetFilter Apply preset filters &#x3D;&gt; 0 no filter 1 no newsstories 2 only newsstories 3 only sapphire 4 only moonstone 5 sapphire and moonstone combined 6 sapphire or moonstone
     * @param fromDate Datas from YYYY-MM-DD (if not provided, last 30 days)
     * @param toDate Datas to YYYY-MM-DD (if not provided, last 30 days)
     * @param country ISO_3166 country code in 2 letters (if not provided  worldwide)
     * @param subcountry state code
     * @param domainFilter Filter answers to pages of a designated domain name
     * @param urlFilter Filter answers to pages URL including a specified string
     * @param categoryFilter Filter answers to a specific page category
     * @param keywordFilter Filter answers to pages titles containing a particular keyword
     * @param lines Get X results (max in one request is 50 please use offset paginated results if you need more)
     * @param offset Get paginated results from X offset
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public pagesGet(presetFilter: number, fromDate?: string, toDate?: string, country?: string, subcountry?: string, domainFilter?: string, urlFilter?: string, categoryFilter?: number, keywordFilter?: string, lines?: number, offset?: number, observe?: 'body', reportProgress?: boolean): Observable<Array<Pages>>;
    public pagesGet(presetFilter: number, fromDate?: string, toDate?: string, country?: string, subcountry?: string, domainFilter?: string, urlFilter?: string, categoryFilter?: number, keywordFilter?: string, lines?: number, offset?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<Pages>>>;
    public pagesGet(presetFilter: number, fromDate?: string, toDate?: string, country?: string, subcountry?: string, domainFilter?: string, urlFilter?: string, categoryFilter?: number, keywordFilter?: string, lines?: number, offset?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<Pages>>>;
    public pagesGet(presetFilter: number, fromDate?: string, toDate?: string, country?: string, subcountry?: string, domainFilter?: string, urlFilter?: string, categoryFilter?: number, keywordFilter?: string, lines?: number, offset?: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (presetFilter === null || presetFilter === undefined) {
            throw new Error('Required parameter presetFilter was null or undefined when calling pagesGet.');
        }











        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (fromDate !== undefined && fromDate !== null) {
            queryParameters = queryParameters.set('from_date', <any>fromDate);
        }
        if (toDate !== undefined && toDate !== null) {
            queryParameters = queryParameters.set('to_date', <any>toDate);
        }
        if (country !== undefined && country !== null) {
            queryParameters = queryParameters.set('country', <any>country);
        }
        if (subcountry !== undefined && subcountry !== null) {
            queryParameters = queryParameters.set('subcountry', <any>subcountry);
        }
        if (domainFilter !== undefined && domainFilter !== null) {
            queryParameters = queryParameters.set('domain_filter', <any>domainFilter);
        }
        if (urlFilter !== undefined && urlFilter !== null) {
            queryParameters = queryParameters.set('url_filter', <any>urlFilter);
        }
        if (categoryFilter !== undefined && categoryFilter !== null) {
            queryParameters = queryParameters.set('category_filter', <any>categoryFilter);
        }
        if (keywordFilter !== undefined && keywordFilter !== null) {
            queryParameters = queryParameters.set('keyword_filter', <any>keywordFilter);
        }
        if (presetFilter !== undefined && presetFilter !== null) {
            queryParameters = queryParameters.set('preset_filter', <any>presetFilter);
        }
        if (lines !== undefined && lines !== null) {
            queryParameters = queryParameters.set('lines', <any>lines);
        }
        if (offset !== undefined && offset !== null) {
            queryParameters = queryParameters.set('offset', <any>offset);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<Pages>>('get',`${this.basePath}/pages`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
