/**
 * DiscoverSnoop
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.240913
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *//* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs';

import { Categories } from '../model/categories';
import { Domains } from '../model/domains';
import { Pages } from '../model/pages';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class LiveService {

    protected basePath = 'https://api.discoversnoop.com';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (const consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * Get livedata stats for categories
     * 
     * @param country ISO_3166 country code in 2 letters
     * @param subcountry state code
     * @param hours Get results for last x hours
     * @param keywordFilter Filter answers to category names containing a particular keyword
     * @param languageFilter Filter answers to pages in specific user language
     * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more)
     * @param offset Get paginated results from X offset
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public livecategoriesGet(country: string, subcountry?: string, hours?: number, keywordFilter?: string, languageFilter?: string, lines?: number, offset?: number, observe?: 'body', reportProgress?: boolean): Observable<Array<Categories>>;
    public livecategoriesGet(country: string, subcountry?: string, hours?: number, keywordFilter?: string, languageFilter?: string, lines?: number, offset?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<Categories>>>;
    public livecategoriesGet(country: string, subcountry?: string, hours?: number, keywordFilter?: string, languageFilter?: string, lines?: number, offset?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<Categories>>>;
    public livecategoriesGet(country: string, subcountry?: string, hours?: number, keywordFilter?: string, languageFilter?: string, lines?: number, offset?: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (country === null || country === undefined) {
            throw new Error('Required parameter country was null or undefined when calling livecategoriesGet.');
        }







        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (country !== undefined && country !== null) {
            queryParameters = queryParameters.set('country', <any>country);
        }
        if (subcountry !== undefined && subcountry !== null) {
            queryParameters = queryParameters.set('subcountry', <any>subcountry);
        }
        if (hours !== undefined && hours !== null) {
            queryParameters = queryParameters.set('hours', <any>hours);
        }
        if (keywordFilter !== undefined && keywordFilter !== null) {
            queryParameters = queryParameters.set('keyword_filter', <any>keywordFilter);
        }
        if (languageFilter !== undefined && languageFilter !== null) {
            queryParameters = queryParameters.set('language_filter', <any>languageFilter);
        }
        if (lines !== undefined && lines !== null) {
            queryParameters = queryParameters.set('lines', <any>lines);
        }
        if (offset !== undefined && offset !== null) {
            queryParameters = queryParameters.set('offset', <any>offset);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<Categories>>('get',`${this.basePath}/livecategories`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Get livedata stats for domains
     * 
     * @param country ISO_3166 country code in 2 letters
     * @param subcountry state code
     * @param urlFilter Filter answers to domains including a specified string
     * @param hours Get results for last x hours
     * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more)
     * @param languageFilter Filter answers to pages in specific user language
     * @param offset Get paginated results from X offset
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public livedomainsGet(country: string, subcountry?: string, urlFilter?: string, hours?: number, lines?: number, languageFilter?: string, offset?: number, observe?: 'body', reportProgress?: boolean): Observable<Array<Domains>>;
    public livedomainsGet(country: string, subcountry?: string, urlFilter?: string, hours?: number, lines?: number, languageFilter?: string, offset?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<Domains>>>;
    public livedomainsGet(country: string, subcountry?: string, urlFilter?: string, hours?: number, lines?: number, languageFilter?: string, offset?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<Domains>>>;
    public livedomainsGet(country: string, subcountry?: string, urlFilter?: string, hours?: number, lines?: number, languageFilter?: string, offset?: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (country === null || country === undefined) {
            throw new Error('Required parameter country was null or undefined when calling livedomainsGet.');
        }







        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (country !== undefined && country !== null) {
            queryParameters = queryParameters.set('country', <any>country);
        }
        if (subcountry !== undefined && subcountry !== null) {
            queryParameters = queryParameters.set('subcountry', <any>subcountry);
        }
        if (urlFilter !== undefined && urlFilter !== null) {
            queryParameters = queryParameters.set('url_filter', <any>urlFilter);
        }
        if (hours !== undefined && hours !== null) {
            queryParameters = queryParameters.set('hours', <any>hours);
        }
        if (lines !== undefined && lines !== null) {
            queryParameters = queryParameters.set('lines', <any>lines);
        }
        if (languageFilter !== undefined && languageFilter !== null) {
            queryParameters = queryParameters.set('language_filter', <any>languageFilter);
        }
        if (offset !== undefined && offset !== null) {
            queryParameters = queryParameters.set('offset', <any>offset);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<Domains>>('get',`${this.basePath}/livedomains`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Get livedata stats for pages
     * 
     * @param country ISO_3166 country code in 2 letters
     * @param presetFilter Apply preset filters &#x3D;&gt; 0 no filter 1 no newsstories 2 only newsstories 3 only sapphire 4 only moonstone 5 sapphire and moonstone combined 6 sapphire or moonstone
     * @param subcountry state code
     * @param hours Get results for last x hours
     * @param onlyNew Get only pages first seen in the reporting period if set on 1
     * @param domainFilter Filter answers to pages of a designated domain name
     * @param keywordFilter Filter answers to pages titles containing a particular keyword
     * @param urlFilter Filter answers to pages URL including a specified string
     * @param categoryFilter Filter answers to pages of a designated category id
     * @param languageFilter Filter answers to pages in specific user language
     * @param lines Get X results (max in one request is 50 please use offset paginated results if you need more)
     * @param offset Get paginated results from X offset
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public livepagesGet(country: string, presetFilter: number, subcountry?: string, hours?: number, onlyNew?: number, domainFilter?: string, keywordFilter?: string, urlFilter?: string, categoryFilter?: number, languageFilter?: string, lines?: number, offset?: number, observe?: 'body', reportProgress?: boolean): Observable<Array<Pages>>;
    public livepagesGet(country: string, presetFilter: number, subcountry?: string, hours?: number, onlyNew?: number, domainFilter?: string, keywordFilter?: string, urlFilter?: string, categoryFilter?: number, languageFilter?: string, lines?: number, offset?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<Pages>>>;
    public livepagesGet(country: string, presetFilter: number, subcountry?: string, hours?: number, onlyNew?: number, domainFilter?: string, keywordFilter?: string, urlFilter?: string, categoryFilter?: number, languageFilter?: string, lines?: number, offset?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<Pages>>>;
    public livepagesGet(country: string, presetFilter: number, subcountry?: string, hours?: number, onlyNew?: number, domainFilter?: string, keywordFilter?: string, urlFilter?: string, categoryFilter?: number, languageFilter?: string, lines?: number, offset?: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (country === null || country === undefined) {
            throw new Error('Required parameter country was null or undefined when calling livepagesGet.');
        }

        if (presetFilter === null || presetFilter === undefined) {
            throw new Error('Required parameter presetFilter was null or undefined when calling livepagesGet.');
        }











        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (country !== undefined && country !== null) {
            queryParameters = queryParameters.set('country', <any>country);
        }
        if (subcountry !== undefined && subcountry !== null) {
            queryParameters = queryParameters.set('subcountry', <any>subcountry);
        }
        if (hours !== undefined && hours !== null) {
            queryParameters = queryParameters.set('hours', <any>hours);
        }
        if (presetFilter !== undefined && presetFilter !== null) {
            queryParameters = queryParameters.set('preset_filter', <any>presetFilter);
        }
        if (onlyNew !== undefined && onlyNew !== null) {
            queryParameters = queryParameters.set('only_new', <any>onlyNew);
        }
        if (domainFilter !== undefined && domainFilter !== null) {
            queryParameters = queryParameters.set('domain_filter', <any>domainFilter);
        }
        if (keywordFilter !== undefined && keywordFilter !== null) {
            queryParameters = queryParameters.set('keyword_filter', <any>keywordFilter);
        }
        if (urlFilter !== undefined && urlFilter !== null) {
            queryParameters = queryParameters.set('url_filter', <any>urlFilter);
        }
        if (categoryFilter !== undefined && categoryFilter !== null) {
            queryParameters = queryParameters.set('category_filter', <any>categoryFilter);
        }
        if (languageFilter !== undefined && languageFilter !== null) {
            queryParameters = queryParameters.set('language_filter', <any>languageFilter);
        }
        if (lines !== undefined && lines !== null) {
            queryParameters = queryParameters.set('lines', <any>lines);
        }
        if (offset !== undefined && offset !== null) {
            queryParameters = queryParameters.set('offset', <any>offset);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<Pages>>('get',`${this.basePath}/livepages`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
