/**
 * DiscoverSnoop
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.240913
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *//* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs';

import { Message } from '../model/message';
import { TransactionInfo } from '../model/transactionInfo';
import { UserInfo } from '../model/userInfo';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class UserService {

    protected basePath = 'https://api.discoversnoop.com';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (const consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * Change user&#x27;s activated countries
     * 
     * @param countries json encoded string representing countries to activate
     * @param categories json encoded string representing categories ID to activate
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public userCountriesChangeGet(countries: string, categories: string, observe?: 'body', reportProgress?: boolean): Observable<Array<TransactionInfo>>;
    public userCountriesChangeGet(countries: string, categories: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<TransactionInfo>>>;
    public userCountriesChangeGet(countries: string, categories: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<TransactionInfo>>>;
    public userCountriesChangeGet(countries: string, categories: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (countries === null || countries === undefined) {
            throw new Error('Required parameter countries was null or undefined when calling userCountriesChangeGet.');
        }

        if (categories === null || categories === undefined) {
            throw new Error('Required parameter categories was null or undefined when calling userCountriesChangeGet.');
        }

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (countries !== undefined && countries !== null) {
            queryParameters = queryParameters.set('countries', <any>countries);
        }
        if (categories !== undefined && categories !== null) {
            queryParameters = queryParameters.set('categories', <any>categories);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<TransactionInfo>>('get',`${this.basePath}/user_countries_change`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Change user customer id. This function is system reserved
     * 
     * @param custid new customer id for user
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public userCustidChangeGet(custid: string, observe?: 'body', reportProgress?: boolean): Observable<Array<TransactionInfo>>;
    public userCustidChangeGet(custid: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<TransactionInfo>>>;
    public userCustidChangeGet(custid: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<TransactionInfo>>>;
    public userCustidChangeGet(custid: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (custid === null || custid === undefined) {
            throw new Error('Required parameter custid was null or undefined when calling userCustidChangeGet.');
        }

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (custid !== undefined && custid !== null) {
            queryParameters = queryParameters.set('custid', <any>custid);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<TransactionInfo>>('get',`${this.basePath}/user_custid_change`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Permanently delete the user
     * 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public userDeleteGet(observe?: 'body', reportProgress?: boolean): Observable<Array<TransactionInfo>>;
    public userDeleteGet(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<TransactionInfo>>>;
    public userDeleteGet(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<TransactionInfo>>>;
    public userDeleteGet(observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<TransactionInfo>>('get',`${this.basePath}/user_delete`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Change user details
     * 
     * @param email new email address for user
     * @param fname new firstname for user
     * @param lname new lastname for user
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public userDetailsChangeGet(email: string, fname: string, lname: string, observe?: 'body', reportProgress?: boolean): Observable<Array<TransactionInfo>>;
    public userDetailsChangeGet(email: string, fname: string, lname: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<TransactionInfo>>>;
    public userDetailsChangeGet(email: string, fname: string, lname: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<TransactionInfo>>>;
    public userDetailsChangeGet(email: string, fname: string, lname: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (email === null || email === undefined) {
            throw new Error('Required parameter email was null or undefined when calling userDetailsChangeGet.');
        }

        if (fname === null || fname === undefined) {
            throw new Error('Required parameter fname was null or undefined when calling userDetailsChangeGet.');
        }

        if (lname === null || lname === undefined) {
            throw new Error('Required parameter lname was null or undefined when calling userDetailsChangeGet.');
        }

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (email !== undefined && email !== null) {
            queryParameters = queryParameters.set('email', <any>email);
        }
        if (fname !== undefined && fname !== null) {
            queryParameters = queryParameters.set('fname', <any>fname);
        }
        if (lname !== undefined && lname !== null) {
            queryParameters = queryParameters.set('lname', <any>lname);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<TransactionInfo>>('get',`${this.basePath}/user_details_change`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Login user with his credentials
     * 
     * @param email email address for user
     * @param password password for user
     * @param pin pin code to validate account creation ; when using pin code, password must be set to \&quot;loginwithpin\&quot;
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public userLoginGet(email: string, password: string, pin?: number, observe?: 'body', reportProgress?: boolean): Observable<Array<UserInfo>>;
    public userLoginGet(email: string, password: string, pin?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<UserInfo>>>;
    public userLoginGet(email: string, password: string, pin?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<UserInfo>>>;
    public userLoginGet(email: string, password: string, pin?: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (email === null || email === undefined) {
            throw new Error('Required parameter email was null or undefined when calling userLoginGet.');
        }

        if (password === null || password === undefined) {
            throw new Error('Required parameter password was null or undefined when calling userLoginGet.');
        }


        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (email !== undefined && email !== null) {
            queryParameters = queryParameters.set('email', <any>email);
        }
        if (password !== undefined && password !== null) {
            queryParameters = queryParameters.set('password', <any>password);
        }
        if (pin !== undefined && pin !== null) {
            queryParameters = queryParameters.set('pin', <any>pin);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<UserInfo>>('get',`${this.basePath}/user_login`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Get messages for user
     * 
     * @param message ID of the requested message. 0 to get the full message list
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public userMessagesGet(message?: number, observe?: 'body', reportProgress?: boolean): Observable<Array<Message>>;
    public userMessagesGet(message?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<Message>>>;
    public userMessagesGet(message?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<Message>>>;
    public userMessagesGet(message?: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {


        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (message !== undefined && message !== null) {
            queryParameters = queryParameters.set('message', <any>message);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<Message>>('get',`${this.basePath}/user_messages`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Change user password
     * 
     * @param email email address for user
     * @param password current password for user
     * @param newpassword new password to set up for user
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public userPasswordChangeGet(email: string, password: string, newpassword: string, observe?: 'body', reportProgress?: boolean): Observable<Array<TransactionInfo>>;
    public userPasswordChangeGet(email: string, password: string, newpassword: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<TransactionInfo>>>;
    public userPasswordChangeGet(email: string, password: string, newpassword: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<TransactionInfo>>>;
    public userPasswordChangeGet(email: string, password: string, newpassword: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (email === null || email === undefined) {
            throw new Error('Required parameter email was null or undefined when calling userPasswordChangeGet.');
        }

        if (password === null || password === undefined) {
            throw new Error('Required parameter password was null or undefined when calling userPasswordChangeGet.');
        }

        if (newpassword === null || newpassword === undefined) {
            throw new Error('Required parameter newpassword was null or undefined when calling userPasswordChangeGet.');
        }

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (email !== undefined && email !== null) {
            queryParameters = queryParameters.set('email', <any>email);
        }
        if (password !== undefined && password !== null) {
            queryParameters = queryParameters.set('password', <any>password);
        }
        if (newpassword !== undefined && newpassword !== null) {
            queryParameters = queryParameters.set('newpassword', <any>newpassword);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<TransactionInfo>>('get',`${this.basePath}/user_password_change`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Reset user password
     * 
     * @param email email address for user
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public userPasswordResetGet(email: string, observe?: 'body', reportProgress?: boolean): Observable<Array<TransactionInfo>>;
    public userPasswordResetGet(email: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<TransactionInfo>>>;
    public userPasswordResetGet(email: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<TransactionInfo>>>;
    public userPasswordResetGet(email: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (email === null || email === undefined) {
            throw new Error('Required parameter email was null or undefined when calling userPasswordResetGet.');
        }

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (email !== undefined && email !== null) {
            queryParameters = queryParameters.set('email', <any>email);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<TransactionInfo>>('get',`${this.basePath}/user_password_reset`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Refresh user rights with his Customer ID. This function is system reserved
     * 
     * @param custid Customer ID for the user
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public userRefreshSubscriptionGet(custid: string, observe?: 'body', reportProgress?: boolean): Observable<Array<UserInfo>>;
    public userRefreshSubscriptionGet(custid: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<UserInfo>>>;
    public userRefreshSubscriptionGet(custid: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<UserInfo>>>;
    public userRefreshSubscriptionGet(custid: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (custid === null || custid === undefined) {
            throw new Error('Required parameter custid was null or undefined when calling userRefreshSubscriptionGet.');
        }

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (custid !== undefined && custid !== null) {
            queryParameters = queryParameters.set('custid', <any>custid);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<UserInfo>>('get',`${this.basePath}/user_refresh_subscription`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Login user with his credentials
     * 
     * @param email email address for user
     * @param password password for user
     * @param fname new firstname for user
     * @param lname new lastname for user
     * @param referrer referrer for this user. should be urlencoded
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public userRegisterGet(email: string, password: string, fname: string, lname: string, referrer?: string, observe?: 'body', reportProgress?: boolean): Observable<Array<UserInfo>>;
    public userRegisterGet(email: string, password: string, fname: string, lname: string, referrer?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<UserInfo>>>;
    public userRegisterGet(email: string, password: string, fname: string, lname: string, referrer?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<UserInfo>>>;
    public userRegisterGet(email: string, password: string, fname: string, lname: string, referrer?: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (email === null || email === undefined) {
            throw new Error('Required parameter email was null or undefined when calling userRegisterGet.');
        }

        if (password === null || password === undefined) {
            throw new Error('Required parameter password was null or undefined when calling userRegisterGet.');
        }

        if (fname === null || fname === undefined) {
            throw new Error('Required parameter fname was null or undefined when calling userRegisterGet.');
        }

        if (lname === null || lname === undefined) {
            throw new Error('Required parameter lname was null or undefined when calling userRegisterGet.');
        }


        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (email !== undefined && email !== null) {
            queryParameters = queryParameters.set('email', <any>email);
        }
        if (password !== undefined && password !== null) {
            queryParameters = queryParameters.set('password', <any>password);
        }
        if (fname !== undefined && fname !== null) {
            queryParameters = queryParameters.set('fname', <any>fname);
        }
        if (lname !== undefined && lname !== null) {
            queryParameters = queryParameters.set('lname', <any>lname);
        }
        if (referrer !== undefined && referrer !== null) {
            queryParameters = queryParameters.set('referrer', <any>referrer);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<UserInfo>>('get',`${this.basePath}/user_register`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
